      subroutine LUx ( mat, LUxmat, nxa, nya, sl1, sl2, sl3, sl4)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer nxa, nya, sl1, sl2, sl3, sl4
      double precision
     +mat(1-sl1:nxa+sl2,1-sl3:nya+sl4,9),
     +LUxmat(1-sl1:nxa+sl2,1-sl3:nya+sl4,3)

c     luxmat    o    LU dec of "diagonal" blocks hor numbering
c     mat       i    The nx x ny x 9 coefficient matrix of the
c                    discrete Laplacian
c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ixa, iya

c     ixa       Counter to number of grid x points on this level
c     iya       Counter to number of grid y points on this level
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c  trivial
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do iya = 1, nya
        LUxmat (1, iya, DIAG) = mat (1, iya, p11)
        LUxmat (1, iya, SUP) = mat (1, iya, p21)
        do ixa = 2, nxa
          LUxMat (ixa, iya, SUB) = mat (ixa, iya, p01)/ LUxMat
     +           (ixa - 1, iya, DIAG)
          LUxmat (ixa, iya, DIAG) = mat (ixa, iya, p11) -
     +           LUxmat (ixa-1, iya, SUP) * LUxmat (ixa, iya, SUB)
          LUxmat (ixa, iya, SUP) = mat (ixa, iya, p21)
        end do
      end do
      end
