      subroutine makegeom (ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.2    15-05-97
c         new cell centered R and P
c         nc = nf/2 + 1 instead of (nf+1)/2
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Calculates sizes of vectors on coarser grids, based on method of
c   coarsening. The centering is always determined by the parity of
c   the number of points in the direction in which coarsening takes
c   place. Even = cell centered, Odd = vertex centered.
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf (*)

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ilevel

c     ilevel    Levelcounter (multi grid levels)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- first we make the sizes.

      if (ibuf (corsnini).eq.FULLCORS) then
        do ilevel = 1, ibuf (hileveli)
          ibuf (sizexi + ilevel) = ibuf (sizexi + ilevel-1)/2 + 1
          ibuf (sizeyi + ilevel) = ibuf (sizeyi + ilevel-1)/2 + 1
        end do
      else
        do ilevel = 1, ibuf (hileveli), 2
          ibuf (sizexi + ilevel) = ibuf (sizexi + ilevel-1)/2 + 1
          ibuf (sizexi + ilevel+1) = ibuf (sizexi + ilevel)
          ibuf (sizeyi + ilevel) = ibuf (sizeyi + ilevel-1)
          ibuf (sizeyi + ilevel+1) = ibuf (sizeyi + ilevel)/2 + 1
        end do
      end if
      end
